/* Generated By:JJTree: Do not edit this line. OAndBlock.java Version 4.3 */
/* JavaCCOptions:MULTI=true,NODE_USES_PARSER=false,VISITOR=true,TRACK_TOKENS=true,NODE_PREFIX=O,NODE_EXTENDS=,NODE_FACTORY=,SUPPORT_CLASS_VISIBILITY_PUBLIC=true */
package com.orientechnologies.orient.core.sql.parser;

import com.orientechnologies.orient.core.db.record.OIdentifiable;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class OAndBlock extends OBooleanExpression {
  List<OBooleanExpression> subBlocks = new ArrayList<OBooleanExpression>();

  public OAndBlock(int id) {
    super(id);
  }

  public OAndBlock(OrientSql p, int id) {
    super(p, id);
  }

  @Override
  public boolean evaluate(OIdentifiable currentRecord) {

    if (getSubBlocks() == null) {
      return true;
    }

    for (OBooleanExpression block : subBlocks) {
      if (!block.evaluate(currentRecord)) {
        return false;
      }
    }
    return true;

  }

  @Override public void replaceParameters(Map<Object, Object> params) {
    for(OBooleanExpression sub:subBlocks){
      sub.replaceParameters(params);
    }
  }

  public List<OBooleanExpression> getSubBlocks() {
    return subBlocks;
  }

  public void setSubBlocks(List<OBooleanExpression> subBlocks) {
    this.subBlocks = subBlocks;
  }

  @Override
  public String toString() {
    if (subBlocks == null || subBlocks.size() == 0) {
      return "";
    }
    if (subBlocks.size() == 1) {
      return subBlocks.get(0).toString();
    }
    StringBuilder result = new StringBuilder();
    boolean first = true;
    for (OBooleanExpression expr : subBlocks) {
      if (!first) {
        result.append(" AND ");
      }
      result.append(expr.toString());
      first = false;
    }
    return result.toString();
  }

  @Override protected boolean supportsBasicCalculation() {
    for(OBooleanExpression expr:subBlocks){
      if(!expr.supportsBasicCalculation()){
        return false;
      }
    }
    return true;
  }

  @Override
  protected int getNumberOfExternalCalculations() {
    int result = 0;
    for (OBooleanExpression expr : subBlocks) {
      result += expr.getNumberOfExternalCalculations();
    }
    return result;
  }

  @Override protected List<Object> getExternalCalculationConditions() {
    List<Object> result = new ArrayList<Object>();
    for(OBooleanExpression expr:subBlocks) {
      result.addAll(expr.getExternalCalculationConditions());
    }
    return result;
  }
}
/* JavaCC - OriginalChecksum=cf1f66cc86cfc93d357f9fcdfa4a4604 (do not edit this line) */
